(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2007-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: helper.mli,v 1.5 2014/01/21 09:21:18 fclement Exp $ *)

val scalar_prod : int array -> int array -> int;;
module IO : sig
  val input_vector : in_channel -> int array option
  val input_matrix : in_channel -> int array array option
  val input_fvector : in_channel -> float array option
  val input_tridiag : in_channel -> Tridiag.t option
  val output_vector : out_channel -> int array -> unit
  val output_raw : out_channel -> float array array -> unit
end;;
val fetch_std_data : string -> string -> int array array * int array;;
val fetch_tri_data : string -> string -> Tridiag.t * float array;;
