(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2007-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: bbp.ml,v 1.10 2014/01/21 09:21:18 fclement Exp $ *)

let bbp k =
  let factor =
    let bf = Big_int.power_int_positive_int 16 k in
    Ratio.inverse_ratio (Ratio.ratio_of_big_int bf) in
  let mk_bbp_frac num x =
    Ratio.div_int_ratio num (Ratio.ratio_of_int (8 * k + x)) in
  Ratio.mult_ratio factor
    (Ratio.sub_ratio (mk_bbp_frac 4 1)
       (Ratio.add_ratio (mk_bbp_frac 2 4)
          (Ratio.add_ratio (mk_bbp_frac 1 5)
             (mk_bbp_frac 1 6))))
;;

let run_steps i =
  let accum out k = Ratio.add_ratio out (bbp k) in
  Ratio.string_of_ratio (List.fold_left accum (Ratio.ratio_of_int 0) i)
;;
