(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2007-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: spawnlib.mli,v 1.21 2014/01/21 09:21:16 fclement Exp $ *)

(* Common functions, used in the Sklml parallel launcher daemon internally *)

open Daemon_types;;

val noimp : unit -> 'a;;
val fail : string -> 'a;;

val maybe : 'a option -> (unit -> 'b) -> ('a -> 'b) -> 'b;;

val install_sighandlers : unit -> unit;;
val spawn_sock : (IO.ic * IO.oc -> 'a -> unit) ->
  'a -> int;;
(* val spawn_pipe : (IO.ic * IO.oc -> 'a -> unit) -> *)
(*   'a -> IO.ic * IO.oc;; *)

val request_slave : IO.ic * IO.oc -> spawn_request ->
  spawn_reply;;
val slave_loop : IO.ic * IO.oc ->
  (spawn_request -> spawn_reply) -> unit;;

type ('state, 'req) request_handler = 'req -> 'state;;
type ('state, 'req) request_generator = 'state -> 'req option;;

val master_loop : ('a, 'b) request_generator -> ('a, 'b) request_handler ->
  'a -> 'a;;
